Attribute VB_Name = "modMain"
Option Explicit
Option Compare Text
DefInt A-Z

'API Types
Public Type SHITEMID
   cb             As Long
   abID           As Byte
End Type

Public Type ITEMIDLIST
   mkid           As SHITEMID
End Type

Public Type BROWSEINFO
   hOwner         As Long
   pidlRoot       As Long
   pszDisplayName As String
   lpszTitle      As String
   ulFlags        As Long
   lpfn           As Long
   lParam         As Long
   iImage         As Long
End Type

'API Constants
Public Const BIF_RETURNONLYFSDIRS = &H1

'API Functions
Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias _
                "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Declare Function SHBrowseForFolder Lib "shell32.dll" Alias _
                "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

'Public variables
Public gobjServer As New SQLDMO.SQLServer
Public gsServerNameSW As String
Public gsLoginSW As String
Public gsPasswordSW As String
Public gvDatabasesSW As Variant
Public gsDestDirSW As String
Public gbDelOldFilesSW As Boolean
Public giDelWeeksSW As Integer
Public gbSaveDTSPackagesSW As Boolean
Public gbScriptAlertsSW As Boolean
Public gbScriptServerLoginsSW As Boolean
Public gbScriptAgentJobsSW As Boolean
Public gbScriptBackupDevicesSW As Boolean
Public gbRunUnAttendedSW As Boolean

Public gbNoGUI As Boolean
Public gsUnattendedLog As String
Public gsLogFile As String

' new command line options
Public gbScriptDB       As Boolean
Public gbScriptTabs     As Boolean
Public gbScriptViews    As Boolean
Public gbScriptSPs      As Boolean
Public gbScriptRules    As Boolean
Public gbScriptDefs     As Boolean
Public gbScriptRoles    As Boolean
Public gbScriptUsers    As Boolean
Public gbScriptUDTs     As Boolean
Public gbScriptFTCs     As Boolean
Public gbObjsInSepFiles As Boolean
Public gbDatePrefix     As Boolean
Public gsSelTables      As String
Public gbScriptDrops1st As Boolean

Public Function BrowseForFolder(szPrompt As String) As String
   Dim biInfo As BROWSEINFO
   Dim pidl As Long
   Dim szPath As String
   
   szPath = Space$(512)
   
   biInfo.hOwner = 0&
   biInfo.pidlRoot = 0&
   biInfo.lpszTitle = szPrompt
   biInfo.ulFlags = BIF_RETURNONLYFSDIRS
   
   pidl = SHBrowseForFolder(biInfo)
   SHGetPathFromIDList ByVal pidl, ByVal szPath
   
   BrowseForFolder = Trim$(szPath)
End Function

Public Sub SaveLog(ByVal gsLogFile As String)
    Dim iFileNumber As Integer
    
    On Error Resume Next
    iFileNumber = FreeFile
    Open gsLogFile For Output As #iFileNumber
    Print #iFileNumber, gsUnattendedLog
    Close #iFileNumber
    DoEvents
End Sub

Public Sub StatusMessage(ByVal strMessage As String)
    Const ciMaxVisualLogLength As Integer = 30000
    Const cstrLogDateTimeFormat As String = "yyyymmdd Hh:Mm:Ss"
    
    Dim strLogEntry As String
    Dim iPos As Integer
    
    On Error Resume Next
    strLogEntry = Format(Now, cstrLogDateTimeFormat) & vbTab & strMessage
    gsUnattendedLog = gsUnattendedLog & strLogEntry & vbNewLine
    If Not gbNoGUI Then
        With frmMain.lblStatus
            .Caption = " " & strMessage
            .Refresh
        End With
        If Len(gsUnattendedLog) > ciMaxVisualLogLength Then
            iPos = InStr(Right$(gsUnattendedLog, ciMaxVisualLogLength), vbNewLine)
            With frmMain.txtLog
                .Text = Right$(gsUnattendedLog, ciMaxVisualLogLength - iPos - 1)
                .SelStart = Len(.Text)
                .Refresh
            End With
        Else
            With frmMain.txtLog
                .Text = gsUnattendedLog
                .SelStart = Len(.Text)
                .Refresh
            End With
        End If
    End If
End Sub

Public Function CreateDataInsert(ByVal vsTableName As String, _
    ByVal vbIdentityPK As Boolean, ByVal vsServer As String, _
    ByVal vsDatabase As String, ByVal vsLogin As String, ByVal vsPwd As String, _
    ByVal vbTrustedConnection As Boolean) As String
    
    Dim k As Integer
    Dim strSql As String, strSql1 As String, strMainSql As String
    Dim sFieldVal As String, sOutput As String
    Dim RS As New ADODB.Recordset
    Dim sDSN As String
    
    If vbTrustedConnection Then
        sDSN = "Provider=SQLOLEDB.1;Persist Security Info=False;" & _
            "Trusted Connection=True;Initial Catalog=" & vsDatabase & _
            ";Data Source=" & vsServer & ""
    Else
        sDSN = "Provider=SQLOLEDB.1;Persist Security Info=False;User ID=" & _
            vsLogin & ";Password=" & vsPwd & ";Initial Catalog=" & vsDatabase & _
            ";Data Source=" & vsServer & ""
    End If
    
    If vbIdentityPK Then
        sOutput = "SET IDENTITY_INSERT " & vsTableName & " ON" & vbNewLine
    Else
        sOutput = ""
    End If
    
    strSql = "insert into " & vsTableName & "("
    RS.
      gTableName & "("
NewLine
    Els  RS.
    onL RS.












     "Trtion ThRALog tbS.







